Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.PictureBox1 = New System.Windows.Forms.PictureBox
        Me.SuspendLayout()
        '
        'PictureBox1
        '
        Me.PictureBox1.Image = CType(resources.GetObject("PictureBox1.Image"), System.Drawing.Image)
        Me.PictureBox1.Location = New System.Drawing.Point(8, 8)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(264, 352)
        Me.PictureBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage
        Me.PictureBox1.TabIndex = 0
        Me.PictureBox1.TabStop = False
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(608, 501)
        Me.Controls.Add(Me.PictureBox1)
        Me.Name = "Form1"
        Me.Text = "ASCII Art Graphics Convertor"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Structure char_info
        Dim character As Short
        Dim r As Integer
        Dim g As Integer
        Dim b As Integer
        Dim attr As Byte

    End Structure

    Dim palette() As char_info

    Dim colour_count As Integer = -1

    Function get_closest_rgb(ByVal r As Integer, ByVal g As Integer, ByVal b As Integer)
        Dim shortest_r As Integer = 100000000
        Dim shortest_n As Integer = 0
        Dim i As Integer
        For i = 0 To colour_count
            Dim range As Integer = Math.Abs(palette(i).r - r) + Math.Abs(palette(i).g - g) + Math.Abs(palette(i).b - b)
            If range < shortest_r Then
                shortest_n = i
                shortest_r = range
            End If
        Next
        Return shortest_n
    End Function
    Sub save_palette_to_disk(ByVal filename As String)
        FileOpen(1, filename, OpenMode.Binary, OpenAccess.Write)
        Dim bt As Byte
        Dim ct As Int16 = colour_count + 1
        FilePut(1, ct)

        Dim i As Integer
        For i = 0 To colour_count
            bt = palette(i).character
            FilePut(1, bt)
            FilePut(1, palette(i).attr)

            bt = palette(i).r : FilePut(1, bt)
            bt = palette(i).g : FilePut(1, bt)
            bt = palette(i).b : FilePut(1, bt)

        Next

        FileClose(1)
    End Sub
    Sub generate_palette_from_bitmap(ByVal bmp As Bitmap)
        Me.CreateGraphics.DrawImage(bmp, 0, 0)
        Dim c As Integer
        Dim x As Integer
        Dim y As Integer

        Dim blocks() As Short = {&HB1, &HB0, &HB2}


        For c = 0 To 2
            For x = c * 128 To c * 128 + 120 Step 8

                For y = 0 To 120 Step 8
                    Dim a As Integer
                    Dim b As Integer
                    Dim c_r As Integer = 0
                    Dim c_g As Integer = 0
                    Dim c_b As Integer = 0
                    For a = x To x + 7
                        For b = y To y + 7
                            Dim c_c As Color = bmp.GetPixel(a, b)
                            c_r += c_c.R
                            c_g += c_c.G
                            c_b += c_c.B
                        Next
                    Next
                    c_r /= 64
                    c_g /= 64
                    c_b /= 64
                    Dim i As Integer
                    Dim already_exists As Boolean = False
                    For i = 0 To colour_count
                        If _
                        palette(i).r = c_r And _
                        palette(i).g = c_g And _
                        palette(i).b = c_b _
                        Then
                            already_exists = True
                            Exit For
                        End If
                    Next
                    If Not (already_exists) Then
                        colour_count += 1
                        ReDim Preserve palette(colour_count)
                        palette(colour_count).r = c_r
                        palette(colour_count).g = c_g
                        palette(colour_count).b = c_b
                        palette(colour_count).attr = ((x \ 8) Mod 16) + (y \ 8) * 16
                        palette(colour_count).character = blocks(c)
                    End If
                Next
            Next
        Next
    End Sub

    Sub load_palette(ByVal filename As String)
        FileOpen(1, filename, OpenMode.Binary, OpenAccess.Read)
        Dim num_cols As Int16

        FileGet(1, num_cols)
        colour_count = num_cols
        Dim i As Integer
        ReDim palette(colour_count)
        colour_count -= 1
        For i = 0 To colour_count
            Dim bt As Byte = 0
            Try
                FileGet(1, bt) : palette(i).character = bt
                FileGet(1, bt) : palette(i).attr = bt
                FileGet(1, bt) : palette(i).r = bt
                FileGet(1, bt) : palette(i).g = bt
                FileGet(1, bt) : palette(i).b = bt
            Catch ex As Exception
                MsgBox("Load palette failed:" & vbCrLf & ex.Message, MsgBoxStyle.Critical, "Load Palette")
                Exit For
            End Try

        Next
        FileClose(1)

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'Dim p As New Bitmap("raw.png")
        'generate_palette_from_bitmap(p)
        'p.Dispose()
        'save_palette_to_disk("D:\My Documents\Visual Studio Projects\ASCII Madness II\default.pal")

        load_palette("..\..\data\default.pal")
    End Sub

    Sub save_image_binary(ByVal pic As Bitmap, ByVal filename As String)
        Dim out As New Bitmap(pic.Width, pic.Height)
        Dim x As Integer
        Dim y As Integer
        If Dir(filename) <> "" Then
            If MsgBox("Would you like to overwrite the file '" & filename & "'?", MsgBoxStyle.YesNo + MsgBoxStyle.Exclamation, "Save Binary") = MsgBoxResult.No Then Exit Sub
            Kill(filename)
        End If
        FileOpen(1, filename, OpenMode.Binary, OpenAccess.Write)
        Dim sz As Int16
        sz = pic.Width
        FilePut(1, sz)
        sz = pic.Height
        FilePut(1, sz)
        Dim raw_file(pic.Width * pic.Height) As Int16
        Dim rle_file(pic.Width * pic.Height) As Int16
        For y = 0 To pic.Height - 1 : For x = 0 To pic.Width - 1
                Dim p As Color = pic.GetPixel(x, y)
                Dim pal As Integer
                If p.R = 255 And p.G = 0 And p.B = 255 Then
                    pal = -2
                Else
                    pal = get_closest_rgb(p.R, p.G, p.B)
                End If

                raw_file(x + y * pic.Width) = pal
                If pal <> -2 Then out.SetPixel(x, y, Color.FromArgb(palette(pal).r, palette(pal).g, palette(pal).b))
            Next x : Next y
        ' Compress
        Dim i As Integer = 0
        Dim j As Integer = 0
        Dim m As Short = 0
        Do While i < pic.Height * pic.Width
            If (i < (pic.Height * pic.Width) - 3) Then
                If (raw_file(i) = raw_file(i + 1) And raw_file(i) = raw_file(i + 2)) Then
                    rle_file(j) = -1 : j = j + 1
                    rle_file(j) = raw_file(i) : j = j + 1
                    m = Short.MaxValue - 1
                    If i + m >= pic.Height * pic.Width Then m = (pic.Height * pic.Width) - i - 1
                    Dim c As Integer
                    For c = 0 To m
                        If raw_file(i) <> rle_file(j - 1) Then Exit For
                        i = i + 1
                    Next c
                    rle_file(j) = c : j = j + 1
                Else
                    rle_file(j) = raw_file(i) : j = j + 1
                    i = i + 1
                End If
            Else
                rle_file(j) = raw_file(i) : j = j + 1
                i = i + 1
            End If
        Loop

        For i = 0 To j - 1
            Dim c As Int16 = rle_file(i)
            FilePut(1, c)
        Next i



        FileClose(1)
        out.Save("OUT.PNG")
    End Sub



    Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click
        save_image_binary(Me.PictureBox1.Image, "D:\My Documents\Visual Studio Projects\ASCII Madness II\Data\end.spr")
        'pic.Save("out.png")
    End Sub
End Class
