#include "stdafx.h"

bool load_sprite(char *filename, sprite *spr_to_load_into) {
	FILE *spr = fopen(filename,"rb");
	if (!spr) {
		return false;
	}
	short img_pxl;
	fread(&(spr_to_load_into->w), sizeof(short), 1, spr);
	fread(&(spr_to_load_into->h), sizeof(short), 1, spr);
	spr_to_load_into->data = new short[spr_to_load_into->w*spr_to_load_into->h];
	int p = 0;
	for (;;) {
		fread(&img_pxl, sizeof(short), 1, spr);
		if (img_pxl==-1) {
			short run_val;
			short run_length;
			fread(&run_val, sizeof(short), 1, spr);
			fread(&run_length, sizeof(short), 1, spr);
			for (short j=0; j<run_length; ++j) {
				spr_to_load_into->data[p++] = run_val;
			}
		} else {
			spr_to_load_into->data[p++] = img_pxl;
		}
		if (p>=spr_to_load_into->h*spr_to_load_into->w) break;
	}
	fclose(spr);
	return true;
}

void blit_sprite(sprite spr, int x, int y) {
	int end_x = x+spr.w;
	int end_y = y+spr.h;
	int start_x = x;
	int start_y = y;
	int inc_read = 0;

	short *s = spr.data;
	

	if (end_x>80) {
		end_x = 80;		
	}
	if (end_y>50) {
		end_y = 50;
	}
	if (start_x<0) {
		start_x = 0;
	}
	if (start_y<0) {
		start_y = 0;
	}

	for (int py=start_y; py<end_y; ++py) {
		for (int px=start_x; px<end_x; ++px) {
			int s_coord = px-x+spr.w*(py-y);
            int d_coord = px+80*py;
			if (spr.data[s_coord]!=-2) {
				console_buffer[d_coord].Attributes = palette[spr.data[s_coord]].Attributes;
				console_buffer[d_coord].Char.AsciiChar = palette[spr.data[s_coord]].Char.AsciiChar;
			}
		}
	}
	
}

void free_sprite(sprite spr) {
	if (spr.data) delete spr.data;
    
}