#include "stdafx.h"

int ox = 40;
int oy = 55;

int oa = 0;
int od = 0;

int progress = 0;

const int texture_size = 64;

int to_Degrees(double angle) {
	return (int)((angle*(texture_size<<8))/6.283185307179586476925286766559);
}

double to_Radians(double angle) {
	return ((angle/(texture_size<<8))*6.283185307179586476925286766559);
}

int *angleTable;
int *depthTable;
int *shadeTable;

sprite tunnel_texture;

bool tunnel_init() {

	// Build LUT:
	
	angleTable = new int[160*160];
	depthTable = new int[160*160];
	shadeTable = new int[160*160];

	for (int x=0; x<160; ++x) for (int y=0; y<160; ++y) {
        int x_A = (x - 80)*8;
        int y_A = (80 - y)*9;
          
		int point_A = 0;

        if (y_A==0) {
            if (x_A < 0) {
                point_A = -texture_size<<6;
			} else {
				point_A = texture_size<<6;
			}
        } else {
            point_A = to_Degrees(atan((double)x_A / (double)y_A));
        }
        
        if (y_A < 0) {
            point_A = point_A + (texture_size<<7);
        }

		while (point_A < 0) point_A+=(texture_size<<8);
		          
        angleTable[x+y*160] = point_A;
               
        double d = pow((double)(pow(y_A/4,2) + pow((double)x_A/4,2)),0.3);
        depthTable[x+y*160] = (int)(97152 / d);

		int shade = (int)(256 - d*32);
		shade+=64;
		
		// Angle-based shading.

		shade -= (int)(128*cos(to_Radians((point_A+texture_size))));

		if (shade>255) shade = 255;
		if (shade<0) shade = 0;

		shadeTable[x+y*160] = shade;

	}
	
	if (!load_sprite("data/bricks.spr", &tunnel_texture)) {
		return false;
	}

	return true;
}

bool tunnel_shut_down() {
	if (angleTable) delete angleTable;
	if (depthTable) delete depthTable;
	if (shadeTable) delete shadeTable;
	free_sprite(tunnel_texture);
	return true;
}



void tunnel_draw_frame(int time) {

		progress+=time;

		ox = 40+(int)(39*sin((double)progress/1200));
		oy = 55+(int)(39*cos((double)progress/2000));

		CHAR_INFO *p = console_buffer;
		short *q = tunnel_texture.data;

		int *a = angleTable+ox+oy*160;
		int *d = depthTable+ox+oy*160;
		int *s = shadeTable+ox+oy*160;

		for (int y=0; y<50; ++y) {
			for (int x=0; x<80; ++x) {
				*p++ = 
						palette
						[
							colour_map
							[
								tunnel_texture.data
								[
									(((oa+*a++)>>6)%texture_size)+
									(((od+*d++)>>7)%texture_size)*texture_size
								]*256+*s++
							]
						];
			}
			a+=80;
			d+=80;
			s+=80;
		}
		od+=time*8;
		oa+=time;
}